"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var package_json_1 = require("../package.json");
var error_1 = require("./typings/error");
var Resource = /** @class */ (function () {
    function Resource(client, endpoint) {
        this.client = client;
        this.endpoint = endpoint;
    }
    Resource.exceptionHandle = function (error) {
        var _a;
        if (error.response.data.hasOwnProperty(error_1.ErrorKeys.ERROR_CODE) &&
            error.response.data.hasOwnProperty(error_1.ErrorKeys.ERROR_INFO)) {
            return _a = {},
                _a[error_1.ErrorKeys.ERROR_CODE] = error.response.data.error_code,
                _a[error_1.ErrorKeys.ERROR_INFO] = error.response.data.error_info,
                _a;
        }
        return error;
    };
    Resource.prototype.get = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var url, response, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        url = id === undefined ? "" + this.endpoint : this.endpoint + "/" + id;
                        return [4 /*yield*/, this.client.get("" + url, this.addPluginData({}))];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response.data];
                    case 2:
                        err_1 = _a.sent();
                        return [2 /*return*/, Resource.exceptionHandle(err_1)];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Resource.prototype.create = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var response, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.client.post("" + this.endpoint, this.addPluginData(data))];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response.data];
                    case 2:
                        err_2 = _a.sent();
                        return [2 /*return*/, Resource.exceptionHandle(err_2)];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Resource.prototype.update = function (id, data) {
        return __awaiter(this, void 0, void 0, function () {
            var response, err_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.client.patch(this.endpoint + "/" + id, this.addPluginData(data))];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response.data];
                    case 2:
                        err_3 = _a.sent();
                        return [2 /*return*/, Resource.exceptionHandle(err_3)];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Resource.prototype.addPluginData = function (data) {
        data.plugin = {
            shop: 'multisafepay-node-wrapper',
            plugin_version: package_json_1.version,
            partner: 'MultiSafepay',
        };
        return data;
    };
    return Resource;
}());
exports.default = Resource;
//# sourceMappingURL=resource.js.map